/* logtraffic.c: log bridge traffic for tcpusb.

   Copyright 2005 Ton van Overbeek.

   This is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.  */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

/* Write buffer to log file in the following format:
 * "d XX XX XX XX XX XX XX XX  XX XX XX XX XX XX XX XX aaaaaaaa aaaaaaaa"
 * where d = direction char: '>' to Palm, '<' from Palm
 *       XX byte value in hex
 *       a corresponding printable char or '.'
 */

void
logtraffic (FILE *logfile, char direction, char *buff, int size)
{
  int i, j;
  char line[70];
  int o1, o2;

  if (!logfile) return;

  for (i = 0; i < size; ) {
    /* prepare line */
    memset (line, ' ', sizeof(line));
    line[0] = direction;

    for (j = 0, o1 = 2, o2 = 51; j < 16 && i < size; i++, j++, buff++) {
      if (j == 8) {
        o1 = 3;
        o2 = 52;
      }
      sprintf (&line[o1 + j*3], "%02x", (*buff & 0xff));
      /* overwrite terminating '\0' from sprintf */
      line[o1 + 2 + j*3] = ' ';
      /* insert printable character or '.' at right place */
      line[o2 + j] = (isprint(*buff)? *buff : '.');
    }
    /* put our own string terminator */
    line[o2 + j] = '\0';

    fprintf (logfile, "%s\n", line);
  }
}
